#include "intersection.h"
#include "vertex.h"
#include "ray.h"

Vertex *getIntersections(Ray *ray)
{
  Vertex *intersection = NULL;
  
  for (int j = 0, num_spheres = spheres.size(); j < num_spheres; j++)
  {
    Vertex *temp = spheres[j]->intersects(ray);
    
    if (intersection != NULL)
    {
      if (temp != NULL)
      {
        if (temp->z > intersection->z)
        {
          delete intersection;
          
          intersection = temp;
          last = 0;
          lindex = j;
        }
      }
    }
    else
    {
      if (temp != NULL)
      {
        delete intersection;
        
        intersection = temp;
        last = 0;
        lindex = j;
      }
      else
      {
        last = -1;
      }
    }
  }
  
  for (int j = 0, num_planes = planes.size(); j < num_planes; j++)
  {
    Vertex *temp = planes[j]->intersects(ray);
    
    if (intersection != NULL)
    {
      if (temp != NULL)
      {
        if (temp->z < intersection->z)
        {
          delete intersection;
           
          intersection = temp;
          last = 1;
          lindex = j;
        }
      }
    }
    else
    {
      if (temp != NULL)
      {
        delete intersection;
        
        intersection = temp;
        last = 1;
        lindex = j;
      }
      else
      {
        last = -1;
      }
    }
  }
  
  return intersection;
}
