#include "parsecommandline.h"

#include <cstring>
#include <cstdlib>

using namespace std;

void parse_commandLine(int argc, char **argv)
{
  for (int i = 1; i < argc; i++)
  {
    string arg(argv[i]);
    
    if (arg == STAGES_1)
    {
      stages = 0;
    }
    else if (arg == STAGES_2)
    {
      stages = 1;
    }
    else if (arg == STAGES_3)
    {
      stages = 2;
    }
    else if (arg == STAGES_4)
    {
      stages = 3;
    }
    else if (arg == WIDTH)
    {   
      if (!(scene_width = atoi(argv[++i])))
      {
        printf("either you specified a non integral width or a width of 0\n");
        exit(1);
      }
    }
    else if (arg == HEIGHT)
    {
      if (!(scene_height = atoi(argv[++i])))
      {
        printf("either you specified a non integral height or a height of 0\n");
        exit(1);
      }
    }
    else if (arg == IN)
    {
      arg = argv[++i];
      
      if (arg.compare(arg.size()-4, 4, ".txt", 4) == 0)
      {
        in_file = arg;
      }
    }
    else if (arg == OUT)
    {
      arg = argv[++i];
      
      if (arg.compare(arg.size()-4, 4, ".ppm", 4) == 0)
      {
        out_file = arg;
      }
    }
  }
  
  if (scene_width == 0)
  {
    printf("scene width not specified\n");
    print_usage();
  }
  
  if (scene_height == 0)
  {
    printf("scene height not specified\n");
    print_usage();
  }
  
  if (in_file.empty())
  {
    printf("no input file specified\n");
    print_usage();
  }
  
  if (out_file.empty())
  {
    printf("no output file specified\n");
    print_usage();
  }
}

void print_usage()
{
  printf("usage:  raytracer [-stages={1 | 2 | 3 | 4}] -width <WIDTH> -height <HEIGHT> -in <IN_FILE> -out <OUT_FILE>\n");
  exit(1);
}


