#include "pixel.h"
#include "ppmconverter.h"
#include <cstdio>
#include <cstdlib>
#include <vector>

PPMConverter::PPMConverter(const char *fname)
{
  if ((out = fopen(fname, "w")) == NULL)
  {
    printf("unable to open '%s' for writing\n", fname);
    exit(1);
  }
}
  
int PPMConverter::writeFile(vector<Pixel*> *pixels)
{
  fprintf(out, "%s\n", MAGIC_NUMBER);
  fprintf(out, "%d %d\n", scene_width, scene_height);
  fprintf(out, "%d\n", 255);
  
  int size = pixels->size();
  int j = 0;
  
  for (int i = 0; i < size; i++, j++)
  {
    unsigned char r = (unsigned char)((*pixels)[i]->red*255);
    unsigned char g = (unsigned char)((*pixels)[i]->green*255);
    unsigned char b = (unsigned char)((*pixels)[i]->blue*255);
    
    if (j == 39)
    {
      fprintf(out, "\n");
      j = 0;
    }
    
    fprintf(out, "%d %d %d    ", r, g, b);
  }
}

int PPMConverter::finish()
{
  fclose(out);
}
