#ifndef _RAY_H
#define _RAY_H

#include "vertex.h"

class Ray
{ 
  public:
    double ox, oy, oz;
    double dx, dy, dz;
    double mag;
    
    Ray(double _ox, double _oy, double _oz, double _dx, double _dy, double _dz);
    double getX() { return dx; }
    double getY() { return dy; }
    double getZ() { return dz; }
    double getMag() { return mag; }
    void normalize();
    double operator ^(Ray ray);
    double operator ^(Vertex vert);
    void operator *(double scalar);
    Ray *operator %(Ray ray);
    Ray *operator -(Ray ray);
};

#endif
